<?php
/**
 * Mod Name: Smilie Groups 1.0
 * Copyright  2006 Smethead
 *
 * admin/sg_smilies.php file.
 */

require "./global.php";

// Load language packs for this section
global $lang;
$lang->load("smilies");
/*$language = $mybb->settings['bblanguage'];
if(!file_exists("../inc/languages/$language/admin/sg.lang.php")){
	$lang->setLanguage("english");
}*/
//$lang->load("sg");
//$lang->setLanguage($mybb->settings['bblanguage']);

addacpnav($lang->nav_smilies, "sg_smilies.php");
switch($mybb->input['action'])
{
	case "add":
		addacpnav($lang->nav_add_smilie);
		break;
	case "edit":
		addacpnav($lang->nav_edit_smilie);
		break;
	case "delete":
		addacpnav($lang->nav_delete_smilie);
		break;
	###########################################
	case "browse_groups":
		addacpnav("Browse Groups");
		break;
	case "add_group":
		addacpnav("Add A Group");
		break;
	case "edit_group":
		addacpnav("Update A Group");
		break;
	case "delete_group":
		addacpnav("Delete A Group");
		break;
	##############################################
}

checkadminpermissions("caneditsmilies");
logadmin();

if($mybb->input['action'] == "do_add")
{
	if(empty($mybb->input['find']) || empty($mybb->input['path']) || empty($mybb->input['name']))
	{
		cperror($lang->error_fill_form);
	}
	$newsmilie = array(
	#################################################
		"gid" => $mybb->input['gid'],
	#################################################
		"name" => addslashes($mybb->input['name']),
		"find" => addslashes($mybb->input['find']),
		"image" => addslashes($mybb->input['path']),
		"disporder" => intval($mybb->input['disporder']),
		"showclickable" =>addslashes( $mybb->input['showclickable'])
		);

	$db->insert_query(TABLE_PREFIX."smilies", $newsmilie);
	$cache->updatesmilies();
	cpredirect("sg_smilies.php", $lang->smilie_added);
}

if($mybb->input['action'] == "do_delete")
{
	if($mybb->input['deletesubmit'])
	{
		$db->query("DELETE FROM ".TABLE_PREFIX."smilies WHERE sid='".intval($mybb->input['sid'])."'");
		$cache->updatesmilies();
		cpredirect("sg_smilies.php", $lang->smilie_deleted);
	}
	else
	{
		$mybb->input['action'] = "modify";
	}
}

if($mybb->input['action'] == "do_edit")
{
	if(empty($mybb->input['find']) || empty($mybb->input['path']) || empty($mybb->input['name']))
	{
		cperror($lang->error_fill_form);
	}
	$smilie = array(
	#################################################
		"gid" => $mybb->input['gid'],
	#################################################
		"name" => addslashes($mybb->input['name']),
		"find" => addslashes($mybb->input['find']),
		"image" => addslashes($mybb->input['path']),
		"disporder" => intval($mybb->input['disporder']),
		"showclickable" =>addslashes( $mybb->input['showclickable'])
		);

	$db->update_query(TABLE_PREFIX."smilies", $smilie, "sid='".intval($mybb->input['sid'])."'");
	$cache->updatesmilies();
	cpredirect("sg_smilies.php", $lang->smilie_updated);
}

if($mybb->input['action'] == "edit")
{
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."smilies WHERE sid='".intval($mybb->input['sid'])."'");
	$smilie = $db->fetch_array($query);
	if(!$smilie['sid'])
	{
		cperror($lang->invalid_smilie);
	}
	$theme['imgdir'] = "images";
	cpheader();
	startform("sg_smilies.php", "", "do_edit");
	makehiddencode("sid", $mybb->input['sid']);
	starttable();
	tableheader($lang->modify_smilie);
	makeinputcode($lang->name, "name", $smilie['name']);
	makeinputcode($lang->text_to_replace, "find", $smilie['find']);
	makeinputcode($lang->image_path, "path", $smilie['image']);
	makeinputcode($lang->disp_order, "disporder", $smilie['disporder']);
	##################################################################
	makeselectcode("Group", "gid", "sg_smiliegroups", "gid", "name", $smilie['gid']);
	#########################################################
	makeyesnocode($lang->show_clickable, "showclickable", $smilie['showclickable']);
	endtable();
	endform($lang->update_smilie, $lang->reset_button);
	cpfooter();
}

if($mybb->input['action'] == "delete")
{
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."smilies WHERE sid='".intval($mybb->input['sid'])."'");
	$smilie = $db->fetch_array($query);
	if(!$smilie['sid'])
	{
		cperror($lang->invalid_smilie);
	}
	cpheader();
	startform("sg_smilies.php", "", "do_delete");
	makehiddencode("sid", $mybb->input['sid']);
	starttable();
	tableheader($lang->delete_smilie, "", 1);
	$yes = makebuttoncode("deletesubmit", $lang->yes);
	$no = makebuttoncode("no", $lang->no);
	makelabelcode("<center>$lang->delete_confirm<br><br>$yes$no</center>", "");
	endtable();
	endform();
	cpfooter();
}

if($mybb->input['action'] == "add")
{
	cpheader();
	if(!$mybb->input['multi'])
	{
		startform("sg_smilies.php", "", "do_add");
		starttable();
		tableheader($lang->add_smilie);
		makeinputcode($lang->name, "name");
		makeinputcode($lang->text_to_replace, "find");
		makeinputcode($lang->image_path, "path", "images/smilies/");
		makeinputcode($lang->disp_order, "disporder");
		##################################################################
		makeselectcode("Group", "gid", "sg_smiliegroups", "gid", "name");
		#########################################################
		makeyesnocode($lang->show_clickable, "showclickable");
		endtable();
		endform($lang->add_smilie, $lang->reset_button);
	}
	else
	{
		startform("sg_smilies.php", "", "addmultiple");
		starttable();
		tableheader($lang->add_multiple);
		makeinputcode($lang->path, "path", "images/smilies");
		makeinputcode($lang->per_page, "perpage", "15");
		endtable();
		endform($lang->browse_for, $lang->reset_button);
	}
	cpfooter();
}

if($mybb->input['action'] == "do_addmultiple")
{
	if($mybb->input['page'])
	{
		$mybb->input['action'] = "addmultiple";
	}
	elseif(!is_array($mybb->input['smimport']))
	{
		cpmessage($lang->sel_no_images);
	}
	else
	{
		reset($mybb->input['smimport']);
		while(list($image,$insert) = each($mybb->input['smimport']))
		{
			if($insert)
			{
				$find = $smcode[$image];
				$name = $smname[$image];
				################################################
				$gid = $smgid[$image];
				################################################
				$imageurl = $path."/".$image;
				$newsmilie = array(
				#################################################
					"gid" => $gid,
				############################################
					"name" => addslashes($name),
					"find" => addslashes($find),
					"image" => addslashes($imageurl),
					"showclickable" => "yes"
				);
				$db->insert_query(TABLE_PREFIX."smilies", $newsmilie);
			}
		}
		$cache->updatesmilies();
		cpheader();
		starttable();
		makelabelcode($lang->all_sel_added);
		endtable();
		echo "<br>";
		$finishedinsert = 1;
		$mybb->input['action'] = "add";
	}
}

if($mybb->input['action'] == "addmultiple")
{
	$perpage = intval($mybb->input['perpage']);
	$page = intval($mybb->input['page']);
	if(!$perpage)
	{
		$perpage = 15;
	}
	$dir = @opendir($mybb->input['path']);
	if(!$dir)
	{
		cperror($lang->bad_directory);
	}
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."smilies");
	while($smilie = $db->fetch_array($query))
	{
		$asmilies[$smilie[image]] = 1;
	}
	while($file = readdir($dir))
	{
		if($file != ".." && $file != ".")
		{
			$ext = getextention($file);
			if($ext == "gif" || $ext == "jpg" || $ext == "jpeg" || $ext == "png" || $ext == "bmp")
			{
				if(!$asmilies["$path/$file"])
				{
					$smilies[] = $file;
				}
			}
		}
	}
	closedir($dir);
	if(!$page)
	{
		$page = 1;
	}
	$newsmilies = count($smilies);
	if($newsmilies > $perpage)
	{
		$pages = $newsmilies / $perpage;
		$pages = ceil($pages);
		for($i=1;$i<=$pages;$i++)
		{
			if($i == $page)
			{
				$pagelist .= " <input type=\"submit\" name=\"page\" value=\"$i\" disabled=\"disabled\"> ";
			}
			else
			{
				$pagelist .= " <input type=\"submit\" name=\"page\" value=\"$i\"> ";
			}
		}
		$start = ($page-1) *$perpage;
	}
	else
	{
		$start = 0;
		$page = 1;
		$pages = 1;
	}
	$end = $perpage + $start;
	if($end > $newsmilies)
	{
		$end = $newsmilies;
	}

	if(!$newsmilies)
	{
		if($finishedmulti)
		{
			cpredirect("sg_smilies.php", $lang->all_sel_added);
		}
		else
		{
			cpmessage($lang->no_images);
		}
	}
	else
	{
		if(!$finishedinsert)
		{
			cpheader();
		}
		startform("sg_smilies.php", "", "do_addmultiple");
		makehiddencode("perpage", $perpage);
		makehiddencode("path", $path);
		starttable();
		################################################
		tableheader($lang->add_multiple, "", "5"); //5 was oorspronkelijk 4
		#################################################
		echo "<tr>\n";
		echo "<td class=\"subheader\" align=\"center\">$lang->image</td>\n";
		echo "<td class=\"subheader\" align=\"center\">$lang->name</td>\n";
		echo "<td class=\"subheader\" align=\"center\">$lang->text_to_replace</td>\n";
		echo "<td class=\"subheader\" align=\"center\">$lang->add</td>\n";
		#########################################
		echo "<td class=\"subheader\" align=\"center\">Group</td>\n";
		##########################################
		echo "</tr>\n";
		for($i=$start;$i<$end;$i++)
		{
			$file = $smilies[$i];
			$ext = getextention($smilies[$i]);
			$find = str_replace(".".$ext, "", $file);
			$name = ucfirst($find);
			$bgcolor = getaltbg();
			echo "<tr>\n";
			echo "<td class=\"$bgcolor\" align=\"center\"><img src=\"../$path/$file\"><br><small>$file</small></td>\n";
			echo "<td class=\"$bgcolor\" align=\"center\"><input type=\"text\" name=\"smname[$file]\" value=\"$name\"></td>\n";
			echo "<td class=\"$bgcolor\" align=\"center\"><input type=\"text\" name=\"smcode[$file]\" value=\":$find:\"></td>\n";
			echo "<td class=\"$bgcolor\" align=\"right\"><input type=\"checkbox\" name=\"smimport[$file]\" value=\"1\">\n";
			###############################################################################################
			$sg_query = $db->query("SELECT gid, name FROM ".TABLE_PREFIX."sg_smiliegroups ORDER BY gid ASC");
			echo "<td class=\"$bgcolor\" align=\"center\"><select name=\"smgid[$file]\">";
			while($sg_array = $db->fetch_array($sg_query)){
				echo "<option value=\"".$sg_array['gid']."\">".$sg_array['name']."</option>";
			}
			echo "</select></td>\n";
			################################################################################################
			echo "</tr>\n";
		}
	}
	if($newsmilies > $perpage)
	{
		tablesubheader($pagelist, "", 4);
	}
	endtable();
	endform($lang->add_multiple, $lang->reset_button);
	cpfooter();
}

if($mybb->input['action'] == "modify" || $mybb->input['action'] == "")
{
	if(!$noheader)
	{
		cpheader();
	}
	#################################################
	$hopto[] = "<input type=\"button\" value=\"Smilie Groups\" onclick=\"hopto('sg_smilies.php?action=browse_groups');\" class=\"hoptobutton\">";
	##################################################
	$hopto[] = "<input type=\"button\" value=\"$lang->add_new_smilie\" onclick=\"hopto('sg_smilies.php?action=add');\" class=\"hoptobutton\">";
	$hopto[] = "<input type=\"button\" value=\"$lang->add_multiple_smilies\" onclick=\"hopto('sg_smilies.php?action=add&multi=1');\" class=\"hoptobutton\">";
	makehoptolinks($hopto);
	starttable();
	tableheader($lang->smilies, "", 5);
	tablesubheader($lang->edit_delete, "", 5);
	$theme[imgdir] = "images";
	$query = $db->query("SELECT COUNT(sid) AS smilies FROM ".TABLE_PREFIX."smilies");
	$smiliecount = $db->result($query, 0);
	$perpage = intval($mybb->input['perpage']);
	$page = intval($mybb->input['page']);
	if(!$perpage)
	{
		$perpage = 15;
	}
	if($page)
	{
		$start = ($page-1) *$perpage;
	}
	else
	{
		$start = 0;
		$page = 1;
	}
	$listed = 0;
	$altbg = "altbg1";
	############################################
	//$query = $db->query("SELECT * FROM ".TABLE_PREFIX."smilies ORDER BY disporder ASC LIMIT $start, $perpage");
	$query = $db->query("SELECT s.*, g.name AS groupname FROM ".TABLE_PREFIX."smilies s, ".TABLE_PREFIX."sg_smiliegroups g WHERE g.gid=s.gid ORDER BY disporder ASC LIMIT $start, $perpage");
	#############################################
	while($smilie = $db->fetch_array($query))
	{
		if($listed == "0")
		{
			echo "<tr>";
		}
		$smilie[image] = str_replace("{theme:imgdir}", $theme[imgdir], $smilie[image]);
		if(strstr($smilie[image], "p://") || substr($smilie[image],0,1) == "/") {
			$image = $smilie[image];
		}
		else
		{
			$image = "../$smilie[image]";
		}
		echo "<td class=\"$altbg\" align=\"center\" valign=\"bottom\" nowrap>$smilie[name]<br><br><img src=\"$image\">&nbsp;&nbsp;<b>".stripslashes($smilie[find])."</b><br>"/*#############################*/.$smilie[groupname]./*#############################*/"<br>";
		echo "<a href=\"sg_smilies.php?action=edit&sid=$smilie[sid]&page=$page&perpage=$perpage\">$lang->edit</a> <a href=\"sg_smilies.php?action=delete&sid=$smilie[sid]&page=$page&perpage=$perpage\">$lang->delete</a>";
		echo "</td>";
		$listed++;
		if($listed == 5)
		{
			echo "</tr>";
			if($altbg == "altbg2")
			{
				$altbg = "altbg1";
			}
			else
			{
				$altbg = "altbg2";
			}
			$listed = 0;
		}
	
	}
	if($listed != "0")
	{
		while($listed != "0")
		{
			echo "<td class=\"$altbg\">&nbsp;</td>";
			$listed++;
			if($listed == "5")
			{
				$listed = 0;
			}
		}
		echo "</tr>";
	}
	if($smiliecount > $perpage)
	{
		$pages = $smiliecount / $perpage;
		$pages = ceil($pages);
		if($page > 1)
		{
			$prev = $page - 1;
			$prevpage = "<a href=\"sg_smilies.php?page=$prev&perpage=$perpage\">$lang->prevpage</a>";
		}
		if($page < $pages)
		{
			$next = $page + 1;
			$nextpage = "<a href=\"sg_smilies.php?page=$next&perpage=$perpage\">$lang->nextpage</a>";
		}
		for($i=1;$i<=$pages;$i++)
		{
			if($i == $page)
			{
				$pagelist .= "<b>$i</b>";
			}
			else
			{
				$pagelist .= "<a href=\"sg_smilies.php?page=$i&perpage=$perpage\">$i</a>";
			}
		}
	}
	if($pagelist || $prevpage  || $nextpage)
	{
		echo "<tr><td class=\"altbg1\" colspan=\"5\">$prevpage $pagelist $nextpage</td></tr>";
	}
	echo "<form action=\"sg_smilies.php?page=$page\" method=\"post\"><tr><td class=\"altbg2\" colspan=\"5\">$lang->smilies_per_page <input type=\"text\" name=\"perpage\" value=\"$perpage\"> <input type=\"submit\" name=\"submit\" value=\"$lang->go\"></td></tr></form>";
	echo "</table>\n";
	echo "</td></tr></table>";
	cpfooter();
}
##################################################################################
#################################################################################
if($mybb->input['action'] == "browse_groups")
{
	if(!$noheader)
	{
		cpheader();
	}
	$hopto[] = "<input type=\"button\" value=\"Smilies\" onclick=\"hopto('sg_smilies.php?action=modify');\" class=\"hoptobutton\">";
	$hopto[] = "<input type=\"button\" value=\"Add Group\" onclick=\"hopto('sg_smilies.php?action=add_group');\" class=\"hoptobutton\">";
	makehoptolinks($hopto);
	starttable();
	tableheader("Smilie Groups", "", 5);
	tablesubheader("Please select a group below to edit or delete.", "", 5);
	$theme[imgdir] = "images";
	$query = $db->query("SELECT COUNT(gid) AS groups FROM ".TABLE_PREFIX."sg_smiliegroups");
	$smiliecount = $db->result($query, 0);
	$perpage = intval($mybb->input['perpage']);
	$page = intval($mybb->input['page']);
	if(!$perpage)
	{
		$perpage = 15;
	}
	if($page)
	{
		$start = ($page-1) *$perpage;
	}
	else
	{
		$start = 0;
		$page = 1;
	}
	$listed = 0;
	$altbg = "altbg1";
	$query = $db->query("SELECT g.* FROM ".TABLE_PREFIX."sg_smiliegroups g ORDER BY g.gid ASC LIMIT $start, $perpage");
	while($smilie = $db->fetch_array($query))
	{
		$smiliequery = $db->query("SELECT image FROM ".TABLE_PREFIX."smilies WHERE gid = '".$smilie['gid']."' ORDER BY disporder ASC LIMIT 0,1");
		$groupsmilie = $db->fetch_array($smiliequery);
		if($listed == "0")
		{
			echo "<tr>";
		}
		$groupsmilie[image] = str_replace("{theme:imgdir}", $theme[imgdir], $groupsmilie[image]);
		if(strstr($groupsmilie[image], "p://") || substr($groupsmilie[image],0,1) == "/") {
			$image = "<img src=\"".$groupsmilie[image]."\">";
		}
		else
		{
			$image = "<img src=\"../$groupsmilie[image]\">";
		}
		if(!$groupsmilie['image']){
			$image = "";
		}
		echo "<td class=\"$altbg\" align=\"center\" valign=\"bottom\" nowrap>$image&nbsp;&nbsp;<br><b>".$smilie['name']."</b><br>";
		echo "<a href=\"sg_smilies.php?action=edit_group&gid=$smilie[gid]&group=true&page=$page&perpage=$perpage\">$lang->edit</a> <a href=\"sg_smilies.php?action=delete_group&gid=$smilie[gid]&group=true&page=$page&perpage=$perpage\">$lang->delete</a>";
		echo "</td>";
		$listed++;
		if($listed == 5)
		{
			echo "</tr>";
			if($altbg == "altbg2")
			{
				$altbg = "altbg1";
			}
			else
			{
				$altbg = "altbg2";
			}
			$listed = 0;
		}
	
	}
	if($listed != "0")
	{
		while($listed != "0")
		{
			echo "<td class=\"$altbg\">&nbsp;</td>";
			$listed++;
			if($listed == "5")
			{
				$listed = 0;
			}
		}
		echo "</tr>";
	}
	if($smiliecount > $perpage)
	{
		$pages = $smiliecount / $perpage;
		$pages = ceil($pages);
		if($page > 1)
		{
			$prev = $page - 1;
			$prevpage = "<a href=\"sg_smilies.php?action=browse_groups&page=$prev&perpage=$perpage\">$lang->prevpage</a>";
		}
		if($page < $pages)
		{
			$next = $page + 1;
			$nextpage = "<a href=\"sg_smilies.php?action=browse_groups&page=$next&perpage=$perpage\">$lang->nextpage</a>";
		}
		for($i=1;$i<=$pages;$i++)
		{
			if($i == $page)
			{
				$pagelist .= "<b>$i</b>";
			}
			else
			{
				$pagelist .= "<a href=\"sg_smilies.php?action=browse_groups&page=$i&perpage=$perpage\">$i</a>";
			}
		}
	}
	if($pagelist || $prevpage  || $nextpage)
	{
		echo "<tr><td class=\"altbg1\" colspan=\"5\">$prevpage $pagelist $nextpage</td></tr>";
	}
	echo "<form action=\"sg_smilies.php?action=browse_groups&page=$page\" method=\"post\"><tr><td class=\"altbg2\" colspan=\"5\">Groups Per Page <input type=\"text\" name=\"perpage\" value=\"$perpage\"> <input type=\"submit\" name=\"submit\" value=\"$lang->go\"></td></tr></form>";
	echo "</table>\n";
	echo "</td></tr></table>";
	cpfooter();
}
if($mybb->input['action'] == "add_group")
{
	cpheader();
	startform("sg_smilies.php", "" , "do_add_group");
	starttable();
	tableheader("Add A Smilie Group");
	makeinputcode("Group Name", "name", $name);
	endtable();
	echo "<br />";
	endform("Add Group", $lang->reset_button);
	cpfooter();
}
if($mybb->input['action'] == "do_add_group")
{
	$query = $db->query("SELECT gid FROM ".TABLE_PREFIX."sg_smiliegroups ORDER BY gid DESC LIMIT 0,1");
	$prev = $db->fetch_array($query);
	$sqlarray = array(
		"gid"	=> $prev['gid']+1,
		"name"	=> $mybb->input['name'],
	);
	$db->insert_query(TABLE_PREFIX."sg_smiliegroups", $sqlarray);
	cpredirect("sg_smilies.php?action=browse_groups", "The Group has been successfully added.");
}
if($mybb->input['action'] == "edit_group")
{
	cpheader();
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."sg_smiliegroups WHERE gid='$gid'");
	$group = $db->fetch_array($query);
	startform("sg_smilies.php", "" , "do_edit_group");
	starttable();
	tableheader("Update Smilie Group: ".$group['name']);
	makehiddencode("gid", $gid);
	makeinputcode("Group Name", "name", $group['name']);
	endtable();
	echo "<br />";
	endform("Update Group", $lang->reset_button);
	cpfooter();
}
if($mybb->input['action'] == "do_edit_group")
{
	$sqlarray = array(
		"gid"	=> $mybb->input['gid'],
		"name"	=> $mybb->input['name'],
	);
	$db->update_query(TABLE_PREFIX."sg_smiliegroups", $sqlarray, "gid='".$mybb->input['gid']."'");
	cpredirect("sg_smilies.php?action=browse_groups", "The Group has been updated successfully.");
}
if($mybb->input['action'] == "delete_group")
{
	$gid = intval($mybb->input['gid']);
	if($gid == "0" || !$gid){
		cperror("You cannot remove this smilie group");
	}
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."sg_smiliegroups WHERE gid='$gid'");
	$group = $db->fetch_array($query);
	cpheader();
	startform("sg_smilies.php", "", "do_delete_group");
	makehiddencode("gid", $gid);
	starttable();
	tableheader("Delete Smilie Group: ".$group['name'], "", 1);
	$yes = makebuttoncode("deletesubmit", $lang->yes);
	$no = makebuttoncode("no", $lang->no);
	makelabelcode("<center>Are you sure you wish to delete the smilie group <b>".$group['name']."</b>? If so, all smilies in this group will be moved to the default smilie group.<br><br>$yes$no</center>", "");
	endtable();
	endform();
	cpfooter();
}
if($mybb->input['action'] == "do_delete_group")
{
	if($mybb->input['deletesubmit'])
	{	
		$gid = intval($mybb->input['gid']);
		$db->query("DELETE FROM ".TABLE_PREFIX."sg_smiliegroups WHERE gid='$gid'");
		$sqlarray = array(
			"gid"	=> 0,
		);
		$db->update_query(TABLE_PREFIX."smilies", $sqlarray, "gid='".$mybb->input['gid']."'");
		cpredirect("sg_smilies.php?action=browse_groups", "The group has been deleted successfully");
	}
	else
	{
		$mybb->input['action'] = "browse_groups";
	}
}
?>
